#include <graphics.h>
#include <dos.h>
#include <math.h>
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>

#define uint unsigned int
#define vbuf (char far *)0xA0000000
#define NP ( 472 )
#define STEPS ( (int)(65535 / 2 / NP ) )
#define DEL ( 15000 * 100.0 / STEPS )

int startp[NP*2]; // coordinate (x,y) dell'immagine di partenza
int endp[NP*2];   // coordinate (x,y) dell'immagine di arrivo

// coordinate morphing
int x_pos[ 65535/2 ], y_pos[ 65535/2 ];

int maxx, maxy;

void calc_morph()
{
uint ip, istep;
int i;
float dx, dy, x, y;

for(ip=0, istep=0; ip<NP*2; ip+=2, istep+=STEPS)
{
 dx = (endp[ip] - startp[ip]) / (float)(STEPS-1);
 dy = (endp[ip+1] - startp[ip+1]) / (float)(STEPS-1);
 x = startp[ip]+0.5;
 y = startp[ip+1]+0.5;

 for(i=0; i<STEPS; i++)
 {
  x_pos[i+istep] = (int)x;
  y_pos[i+istep] = (int)y;
  x+=dx;
  y+=dy;
 }

}
}
#define MODCOL 15

void opengraph(void)
{
 int gdriver = VGA, gmode = VGAHI, errorcode;
 int i;

 initgraph(&gdriver, &gmode, "C:\\BORLANDC\\BGI");

 errorcode = graphresult();
   if (errorcode != grOk)
   {  printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:"); getch();
      exit(1); }

  maxx=getmaxx();
  maxy=getmaxy();

  for(i=1; i<256; i++)
  {
   outp(968, i);
   outp(969, 63);
   outp(969, i*4);
   outp(969, 63);
  }
}



void main(void)
{
uint off, npoint, ip;
int i, p=0;
float nx, ny, z;
int rx, ry, cx, cy, x, y;

opengraph();
randomize();

for(i=0; i<NP*2; i+=2)
{
 startp[i]=rand()%maxx;
 startp[i+1]=rand()%maxy;
 repx:
 x_pos[i>>1] = rand()%5 - 2;
 if(!x_pos[i>>1]) goto repx;
 repy:
 y_pos[i>>1] = rand()%5 - 2;
 if(!y_pos[i>>1]) goto repy;
}


while(!kbhit())
{
 for(i=0, ip=0; i<NP*2; i+=2, ip++)
 {
  x = startp[i];
  y = startp[i+1];
  if(x > maxx || x < 1) x_pos[ip]*=-1;
  if(y > maxy || y < 1) y_pos[ip]*=-1;
  putpixel(x, y, 0);
  startp[i]+=x_pos[ip];
  startp[i+1]+=y_pos[ip];
  putpixel(startp[i], startp[i+1], ip%15+1);
 }
 for(off=0; off<DEL/2; off++);
}
getch();


while(!kbhit())
{

nx = (random(60)+1)/10.0-3;
if(nx==0.0) nx=1;
ny = (random(60)+1)/10.0-3;
if(ny==0.0) ny=1;

//rx = random(maxx/2); if(rx<100) rx=100;
rx=maxx/2;
 if(rand() & 1) rx=-rx;
//ry = random(maxy/2); if(ry<100) ry=100;
ry=maxy/2;
 if(rand() & 1) ry=-ry;
if(p==3) { rx=abs(rx); ry=abs(ry); }

//cx=abs(rx) + rand() % (maxx/2-abs(rx));
//cy=abs(ry) + rand() % (maxy/2-abs(rx));
cx=maxx/2;
cy=maxy/2;


p++;

for(i=0; i<NP*2; i+=2)
{

switch ( (p>>1) % 9 )
{
 case 0:
    endp[i]   = sin(M_PI/NP*i*nx*2)*rx + cx;
    endp[i+1] = cos(M_PI/NP*i*ny*2)*ry + cy;
   break;
 case 1:
    endp[i]   = sin(M_PI/NP*i*nx*2)*rx/(NP*2.0)*i + cx;
    endp[i+1] = cos(M_PI/NP*i*nx*2)*ry/(NP*2.0)*i + cy;
   break;
 case 2:
    endp[i]   = cos(M_PI/NP*i*nx*2)*rx/(NP*2.0)*i + cx;
    endp[i+1] = sin(M_PI/NP*i*nx*2)*ry/(NP*2.0)*(NP*2-i) + cy;
   break;
 case 3:
    endp[i]   = random((int)(nx*maxx/6)) + maxx/2;
    endp[i+1] = random((int)(ny*maxy/6)) + maxy/2;
   break;
 case 4:
    endp[i]   = maxx/2 + cos(M_PI/NP*i)*sin(M_PI/NP*i*nx)* rx;
    endp[i+1] = maxy/2 + sin(M_PI/NP*i)*cos(M_PI/NP*i*ny)* ry;
   break;
 case 5:
    endp[i]   = maxx/(NP*2.0)*i;
    endp[i+1] = (sin(M_PI/NP*i*nx*2) + sin(M_PI/NP*i*ny*2))*ry/2+cy;
   break;
 case 6:
    z = 4.0 / ((NP*2.0)/32.0) * (int)(i/32)+1.0;
    endp[i]   = cos(M_PI/16*(i%32) + M_PI/2.0*(z/nx))*rx/z+cx;
    endp[i+1] = sin(M_PI/16*(i%32) + M_PI/2.0*(z/ny))*ry/z+cy;
   break;
 case 7:
    z = (4.0/3.0*fabs(ny)) / 32.0 * (int)(i%64) + 1.0/3.0*fabs(nx)+1.0;
    endp[i]   = (maxx/64.0*(i%64 - 32)+sin(M_PI/32.0*(i%64)*nx)*cx/2.0)/z + cx;
    endp[i+1] = (maxy/(NP*2.0/64.0) * (int)(i / 64)-cy)/z+cy;
   break;
 case 8:
    endp[i]   = cos(M_PI/NP*i)*(maxx/2)*(cos(M_PI/NP*i*nx*2)) + maxx/2;
    endp[i+1] = sin(M_PI/NP*i)*(maxy/2)*(sin(M_PI/NP*i*ny*2)) + maxy/2;

}

}

calc_morph();


for(i=0; i<STEPS; i++)
{
 for(ip=0, npoint=0; ip<NP; ip++, npoint+=STEPS)
  {
   putpixel(x_pos[i-1 + npoint], y_pos[i-1 + npoint], 0);
   putpixel(x_pos[i + npoint], y_pos[i + npoint], (ip % 15)+1);
  }
 for(off=0; off<DEL; off++);
}




for(i=0; i<NP*2; i++) startp[i] = endp[i];


}
getch();


for(i=0; i<STEPS; i++)
{
 x_pos[i]=maxx;
 y_pos[i]=(maxy)/(float)STEPS*i;

 x_pos[i+STEPS]=(maxx)/(float)STEPS*i;
 y_pos[i+STEPS]=maxy;
}

cleardevice();
for(i=0; i<STEPS; i++)
{
setcolor(i%15+1);
 line(x_pos[i], y_pos[i], x_pos[STEPS*2-i-1], y_pos[STEPS*2-i-1]);
 line(maxx-x_pos[i], maxy-y_pos[i], maxx-x_pos[STEPS*2-i-1], maxy-y_pos[STEPS*2-i-1]);
}
getch();


closegraph();

}